% !TEX root = main.tex

\section{Conclusion}
\label{section:conclusion}

We proposed D-Cliques, a sparse topology that obtains similar convergence
speed as a fully-connected network in the presence of label distribution skew.
D-Cliques is based on assembling subsets of nodes into cliques such
that the clique-level class distribution is representative of the global
distribution, thereby locally recovering homogeneity of data. Cliques are
connected together by a
sparse inter-clique topology so that
they quickly converge to the same model. We proposed Clique
Averaging to remove the bias in gradient computation due to non-homogeneous
averaging neighborhood by averaging gradients only with other nodes within the clique. Clique Averaging
can in turn be used to implement an effective momentum.
% to recover the
% convergence
% speed usually only possible with IID mini-batches.
Through our extensive set of experiments, we
showed that the clique structure of D-Cliques is critical in obtaining these
results and that a small-world inter-clique topology with only $O(n \log n)$ 
edges achieves a very good compromise between
convergence speed and scalability with the number of nodes.

% More generally, our empirical results call for refined convergence analyses of
% decentralized FL that precisely capture the interplay between data
% heterogeneity and network topology.

The ideas of D-Cliques can be useful to
implement fully decentralized
learning in a
wider range of heterogeneous environments.
% where global coordination is
% impossible or too costly.
Future works include evaluating D-Cliques in more
challenging settings (node failures including adversaries, arrival and departure of
nodes, non-uniform latency between pairs of nodes) and dynamically constructing the topology 
\emph{while} optimizing the model. 
% As we have sketched, the relative frequency of classes in each
% node
% could be computed using PushSum~\cite{kempe2003gossip}, and the topology could
% be constructed in a decentralized way with
% PeerSampling~\cite{jelasity2007gossip}. This will be investigated in future work, 
% using these results as a design foundation.
More general types of data heterogeneity could be tackled: An important
example is
covariate shift or feature distribution skew \cite{kairouz2019advances}, for
which local density estimates could be used as basis to construct cliques that
approximately recover the global distribution.